/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pe.siso.academia.Servlets;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.json.JSONObject;
import pe.siso.academia.Beans.Usuario;
import pe.siso.academia.Services.AsistenciaService;

/**
 *
 * @author Felipe Escala
 */
public class ServletAsistencia extends HttpServlet {

	@Override
	protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		response.setContentType("text/html");
		String accion = request.getParameter("accion");
		switch (accion) {
			case "listarAsistencia":
				listarAsistencia(request, response);
				break;
			case "editarAsistencias":
				editarAsistencias(request, response);
				break;
			case "registrarAsistencia":
				registrarAsistencia(request, response);
				break;
			case "eliminarAsistencia":
				eliminarAsistencia(request, response);
				break;
			case "listarCicloPorEstudiante":
				listarCicloPorEstudiante(request, response);
				break;
			case "listarEstudiantesPorCiclo":
				listarEstudiantesPorCiclo(request, response);
				break;
			case "listarClasesPorCiclo":
				listarClasesPorCiclo(request, response);
				break;
			default:
		}
	}

	private void listarAsistencia(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		AsistenciaService srv = new AsistenciaService();
		HttpSession session_actual = request.getSession(true);
		Usuario usuario = (Usuario) session_actual.getAttribute("usuario");
		String jsonString = request.getParameter("json");
		JSONObject json = new JSONObject(jsonString);
		json.put("draw", Integer.parseInt(request.getParameter("draw")));
		json.put("length", Integer.parseInt(request.getParameter("length")));
		json.put("start", Integer.parseInt(request.getParameter("start")));
		json.put("codigoSede", usuario.getCodigoSede());
		JSONObject rs = srv.listarAsistencia(json);
		out.println(rs);
	}

	private void editarAsistencias(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		AsistenciaService srv = new AsistenciaService();
		String jsonString = request.getParameter("json");
		JSONObject json = new JSONObject(jsonString);
		JSONObject rs = srv.editarAsistencias(json);
		out.println(rs);
	}

	private void registrarAsistencia(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		AsistenciaService srv = new AsistenciaService();
		String jsonString = request.getParameter("json");
		JSONObject json = new JSONObject(jsonString);
		JSONObject rs = srv.registrarAsistencia(json);
		out.println(rs);
	}

	private void eliminarAsistencia(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		AsistenciaService srv = new AsistenciaService();
		String jsonString = request.getParameter("json");
		JSONObject json = new JSONObject(jsonString);
		JSONObject rs = srv.eliminarAsistencia(json);
		out.println(rs);
	}

	private void listarCicloPorEstudiante(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		HttpSession session_actual = request.getSession(true);
		Usuario usuario = (Usuario) session_actual.getAttribute("usuario");
		AsistenciaService srv = new AsistenciaService();
		String jsonString = request.getParameter("json");
		JSONObject json = new JSONObject(jsonString);
		json.put("codigoSede", usuario.getCodigoSede());
		JSONObject rs = srv.listarCicloPorEstudiante(json);
		out.println(rs);
	}

	private void listarEstudiantesPorCiclo(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		AsistenciaService srv = new AsistenciaService();
		String jsonString = request.getParameter("json");
		JSONObject json = new JSONObject(jsonString);
		JSONObject rs = srv.listarEstudiantesPorCiclo(json);
		out.println(rs);
	}

	private void listarClasesPorCiclo(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		AsistenciaService srv = new AsistenciaService();
		String jsonString = request.getParameter("json");
		JSONObject json = new JSONObject(jsonString);
		JSONObject rs = srv.listarClasesPorCiclo(json);
		out.println(rs);
	}

}
