/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pe.siso.academia.Servlets;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.json.JSONObject;
import pe.siso.academia.Beans.Usuario;
import pe.siso.academia.Services.RecuperacionService;

/**
 *
 * @author Felipe Escala
 */
public class ServletRecuperacion extends HttpServlet {

	@Override
	protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		String param = request.getParameter("accion");
		if (null != param) {
			switch (param) {
				case "listarRecuperaciones":
					listarRecuperaciones(request, response);
					break;
				case "eliminarRecuperacion":
					eliminarRecuperacion(request, response);
					break;
				case "nuevaRecuperacion":
					nuevaRecuperacion(request, response);
					break;
				case "listarCiclos":
					listarCiclos(request, response);
					break;
				case "editarRecuperacion":
					editarRecuperacion(request, response);
					break;
				default:
					break;
			}
		}
	}

	private void listarRecuperaciones(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		String jsonString = request.getParameter("json");
		HttpSession session_actual = request.getSession(true);
		Usuario usuario = (Usuario) session_actual.getAttribute("usuario");
		JSONObject json = new JSONObject(jsonString);
		json.put("draw", Integer.parseInt(request.getParameter("draw")));
		json.put("length", Integer.parseInt(request.getParameter("length")));
		json.put("start", Integer.parseInt(request.getParameter("start")));
		json.put("codigoSede", usuario.getCodigoSede());
		RecuperacionService srv = new RecuperacionService();
		JSONObject rs = srv.listarRecuperaciones(json);
		out.println(rs);
	}

	private void eliminarRecuperacion(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		String jsonString = request.getParameter("json");
		JSONObject json = new JSONObject(jsonString);
		RecuperacionService srv = new RecuperacionService();
		JSONObject rs = srv.eliminarRecuperacion(json);
		out.println(rs);
	}

	private void nuevaRecuperacion(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		String jsonString = request.getParameter("json");
		JSONObject json = new JSONObject(jsonString);
		RecuperacionService srv = new RecuperacionService();
		JSONObject rs = srv.nuevaRecuperacion(json);
		out.println(rs);
	}

	private void listarCiclos(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		String jsonString = request.getParameter("json");
		JSONObject json = new JSONObject(jsonString);
		HttpSession session_actual = request.getSession(true);
		Usuario usuario = (Usuario) session_actual.getAttribute("usuario");
		json.put("codigoSede", usuario.getCodigoSede());
		RecuperacionService srv = new RecuperacionService();
		JSONObject rs = srv.listarCiclos(json);
		out.println(rs);
	}

	private void editarRecuperacion(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		String jsonString = request.getParameter("json");
		JSONObject json = new JSONObject(jsonString);
		RecuperacionService srv = new RecuperacionService();
		JSONObject rs = srv.editarRecuperacion(json);
		out.println(rs);
	}

}
